/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Contents of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.37 - (show annotations) (download)
Fri Nov 14 05:25:46 2003 UTC (20 years, 4 months ago) by heimbach
Branch: MAIN
Changes since 1.36: +5 -1 lines
added target 'adtafonly' to enable splitting of build process
into local compile and remote taf (where it is available)

1 #!/bin/sh
2 #
3 # $Header: /u/gcmpack/MITgcm/tools/genmake2,v 1.36 2003/11/14 02:48:18 edhill Exp $
4 #
5 # Makefile generator for MITgcm UV codes
6 # created by cnh 03/98
7 # adapted by aja 06/98
8 # modified by aja 01/00
9 # rewritten in bash by eh3 08/03
10
11 # Search for particular CPP #cmds associated with packages
12 # usage: test_for_package_in_cpp_options CPP_file package_name
13 test_for_package_in_cpp_options() {
14 cpp_options=$1
15 pkg=$2
16 grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
17 RETVAL=$?
18 if test "x${RETVAL}" = x0 ; then
19 echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"
20 exit 99
21 fi
22 grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
23 RETVAL=$?
24 if test "x${RETVAL}" = x0 ; then
25 echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"
26 exit 99
27 fi
28 grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
29 RETVAL=$?
30 if test "x${RETVAL}" = x0 ; then
31 echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"
32 exit 99
33 fi
34 grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
35 RETVAL=$?
36 if test "x${RETVAL}" = x0 ; then
37 echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"
38 exit 99
39 fi
40 }
41
42 # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
43 # the package list.
44 expand_pkg_groups() {
45 new_packages=
46 PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47 if test -r $PKG_GROUPS ; then
48 cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49 cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50 matched=0
51 for i in $PACKAGES ; do
52 line=`grep "^ *$i" ./p2.tmp`
53 RETVAL=$?
54 if test "x$RETVAL" = x0 ; then
55 matched=1
56 replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
57 echo " replacing \"$i\" with: $replace"
58 new_packages="$new_packages $replace"
59 else
60 new_packages="$new_packages $i"
61 fi
62 done
63 PACKAGES=$new_packages
64 rm -f ./p[1,2].tmp
65 else
66 echo "Warning: can't read package groups definition file: $PKG_GROUPS"
67 fi
68 }
69
70 # Guess possible config options for this host
71 find_possible_configs() {
72
73 tmp1=`uname`"_"`uname -m`
74 tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75 tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
76 PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
77 OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
78 echo " The platform appears to be: $PLATFORM"
79 # if test "x$OFLIST" = x ; then
80 # echo " No pre-defined options files were found matching this platform"
81 # echo " but examples for other platforms can be found in:"
82 # echo " $ROOTDIR/tools/build_options"
83 # else
84 # echo " Options files (located in $ROOTDIR/tools/build_options) that"
85 # echo " may work with this machine are:"
86 # for i in $OFLIST ; do
87 # echo " $i"
88 # done
89 # fi
90
91 echo "test" > test
92 ln -s ./test link
93 RETVAL=$?
94 if test "x${RETVAL}" = x0 ; then
95 LN="ln -s"
96 else
97 echo "Error: \"ln -s\" does not appear to work on this system!"
98 echo " For help, please contact <MITgcm-support@mitgcm.org>."
99 exit 1
100 fi
101 rm -f test link
102
103 if test "x$CPP" = x ; then
104 CPP="cpp -traditional -P"
105 fi
106
107 # makedepend is not always available
108 if test "x${MAKEDEPEND}" = x ; then
109 which makedepend >& /dev/null
110 RETVAL=$?
111 if test "x${RETVAL}" = x1 ; then
112 echo " makedepend was not found. Using xmakedpend instead."
113 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
114 fi
115 fi
116
117 # look for possible fortran compilers
118 tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
119 p_FC=
120 for c in $tmp ; do
121 rm -f ./hello.f ./hello
122 cat >> hello.f <<EOF
123 program hello
124 do i=1,3
125 print *, 'hello world : ', i
126 enddo
127 end
128 EOF
129 $c -o hello hello.f > /dev/null 2>&1
130 RETVAL=$?
131 if test "x${RETVAL}" = x0 ; then
132 p_FC="$p_FC $c"
133 fi
134 done
135 rm -f ./hello.f ./hello
136 if test "x${p_FC}" = x ; then
137 cat 1>&2 <<EOF
138
139 Error: No Fortran compilers were found in your path. Please specify one using:
140
141 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
142 2) a command-line option (eg. "-fc NAME"), or
143 3) the MITGCM_FC environment variable.
144
145 EOF
146 exit 1
147 else
148 echo " The possible FORTRAN compilers found in your path are:"
149 echo " "$p_FC
150 if test "x$FC" = x ; then
151 FC=`echo $p_FC | $AWK '{print $1}'`
152 fi
153 fi
154
155 for i in $p_FC ; do
156 p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
157 if test -r $p_OF ; then
158 OPTFILE=$p_OF
159 echo " The options file: $p_OF"
160 echo " appears to match so we'll use it."
161 break
162 fi
163 done
164 if test "x$OPTFILE" = x ; then
165 cat 1>&2 <<EOF
166
167 Error: No options file was found in: $ROOTDIR/tools/build_options/
168 that matches this platform ("$PLATFORM") and the compilers found in
169 your path. Please specify an "optfile" using:
170
171 1) the command line (eg. "-optfile=path/to/OPTFILE"), or
172 2) the MITGCM_OF environment variable.
173
174 If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
175
176 EOF
177 exit 1
178 fi
179
180 # # look for possible MPI libraries
181 # mpi_libs=
182 # mpi_fort=`which mpif77 2>/dev/null`
183 # RETVAL=$?
184 # if test "x${RETVAL}" = x0 ; then
185 # cat >>test.f <<EOF
186 # PROGRAM HELLO
187 # DO 10, I=1,10
188 # PRINT *,'Hello World'
189 # 10 CONTINUE
190 # STOP
191 # END
192 # EOF
193 # eval "$mpi_fort -showme test.f > out"
194 # RETVAL=$?
195 # if test "x${RETVAL}" = x0 ; then
196 # a=`cat out`
197 # for i in $a ; do
198 # case $i in
199 # -*)
200 # mpi_libs="$mpi_libs $i" ;;
201 # esac
202 # done
203 # echo "The MPI libs appear to be:"
204 # echo " "$mpi_libs
205 # fi
206 # rm -f test.f out
207 # fi
208
209 }
210
211 # Parse the package dependency information
212 get_pdepend_list() {
213
214 # strip the comments and then convert the dependency file into
215 # two arrays: PNAME, DNAME
216 cat $1 | sed -e 's/#.*$//g' \
217 | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
218 > ./.pd_tmp
219 . ./.pd_tmp
220 rm -f ./.pd_tmp
221
222 echo -n "PNAME = "${}
223 }
224
225
226 # Explain usage
227 usage() {
228 echo
229 echo "Usage: "$0" [OPTIONS]"
230 echo " where [OPTIONS] can be:"
231 echo
232 echo " -help | --help | -h | --h"
233 echo " -nooptfile | --nooptfile"
234 echo " -optfile NAME | --optfile NAME | -of NAME | --of NAME"
235 echo " -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"
236 echo " -pdepend NAME | --pdepend NAME"
237 echo " -pdepend=NAME | --pdepend=NAME"
238 echo " -pdefault NAME | --pdefault NAME"
239 echo " -pdefault=NAME | --pdefault=NAME"
240 echo " -make NAME | -m NAME"
241 echo " --make=NAME | -m=NAME"
242 echo " -makefile NAME | -mf NAME"
243 echo " --makefile=NAME | -mf=NAME"
244 echo " -platform NAME | --platform NAME | -pl NAME | --pl NAME"
245 echo " -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"
246 echo " -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"
247 echo " -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"
248 echo " -mods NAME | --mods NAME | -mo NAME | --mo NAME"
249 echo " -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"
250 echo " -disable NAME | --disable NAME"
251 echo " -disable=NAME | --disable=NAME"
252 echo " -enable NAME | --enable NAME"
253 echo " -enable=NAME | --enable=NAME"
254 echo " -standarddirs NAME | --standarddirs NAME"
255 echo " -standarddirs=NAME | --standarddirs=NAME"
256 echo " -noopt NAME | --noopt NAME"
257 echo " -noopt=NAME | --noopt=NAME"
258 # echo " -cpp NAME | --cpp NAME"
259 # echo " -cpp=NAME | --cpp=NAME"
260 echo " -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"
261 echo " -fc=NAME | --fc=NAME"
262 echo " -[no]ieee | --[no]ieee"
263 echo " -[no]mpi | --[no]mpi"
264 echo " -[no]jam | --[no]jam"
265 echo
266 echo " and NAME is a string such as:"
267 echo
268 echo " --enable pkg1 --enable 'pkg1 pkg2' --enable 'pkg1 pkg2 pkg3'"
269 echo " -mods=dir1 -mods='dir1' -mods='dir1 dir2 dir3'"
270 echo " -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"
271 echo
272 echo " which, depending upon your shell, may need to be single-quoted"
273 echo " if it contains spaces, dashes, or other special characters."
274 exit 1
275 }
276
277 # Build a CPP macro to automate calling C routines from FORTRAN
278 get_fortran_c_namemangling() {
279 default_nm="#define FC_NAMEMANGLE(X) X ## _"
280
281 cat > genmake_test.c <<EOF
282 void tcall( char * string ) { tsub( string ); }
283 EOF
284 $MAKE genmake_test.o > genmake_test.log 2>&1
285 RETVAL=$?
286 if test "x$RETVAL" != x0 ; then
287 cat genmake_test.log >> genmake_errors
288 FC_NAMEMANGLE=$default_nm
289 echo
290 echo "WARNING: C test compile fails -- please see \"genmake_errors\""
291 echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
292 echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
293 return 1
294 fi
295 c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`
296 RETVAL=$?
297 if test "x$RETVAL" != x0 ; then
298 FC_NAMEMANGLE=$default_nm
299 echo
300 echo "WARNING: The \"nm\" command failed."
301 echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
302 echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
303 return 1
304 fi
305 cat > genmake_tcomp.f <<EOF
306 subroutine tcall( string )
307 character*(*) string
308 call tsub( string )
309 end
310 EOF
311 $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1
312 RETVAL=$?
313 if test "x$RETVAL" != x0 ; then
314 cat genmake_tcomp.log >> genmake_errors
315 FC_NAMEMANGLE=$default_nm
316 echo
317 echo "WARNING: FORTRAN test compile fails -- please see \"genmake_errors\""
318 echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
319 echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
320 return 1
321 fi
322 f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`
323 RETVAL=$?
324 if test "x$RETVAL" != x0 ; then
325 FC_NAMEMANGLE=$default_nm
326 echo
327 echo "WARNING: The \"nm\" command failed."
328 echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
329 echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
330 return 1
331 fi
332
333 c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
334 f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
335 c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
336 f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
337
338 nmangle="X"
339 if test "x$c_a" != "x$f_a" ; then
340 comm="echo x$f_a | sed -e 's|x$c_a||'"
341 a=`eval $comm`
342 nmangle="$a ## $nmangle"
343 fi
344 if test "x$c_b" != "x$f_b" ; then
345 comm="echo x$f_b | sed -e 's|x$c_b||'"
346 b=`eval $comm`
347 nmangle="$nmangle ## $b"
348 fi
349
350 FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) $nmangle"
351
352 # cleanup the testing files
353 rm -f genmake_tcomp.* genmake_test.*
354 }
355
356 # Set defaults here
357 COMMANDL="$0 $@"
358
359 PLATFORM=
360 LN=
361 S64=
362 KPP=
363 FC=
364 LINK=
365 # DEFINES="-DWORDLENGTH=4"
366 DEFINES=
367 PACKAGES=
368 ENABLE=
369 DISABLE=
370 MAKEFILE=
371 MAKEDEPEND=
372 PDEPEND=
373 DUMPSTATE=t
374 PDEFAULT=
375 OPTFILE=
376 INCLUDES="-I."
377 FFLAGS=
378 FOPTIM=
379 CFLAGS=
380 KFLAGS1=
381 KFLAGS2=
382 LIBS=
383 KPPFILES=
384 NOOPTFILES=
385 NOOPTFLAGS=
386
387 # DEFINES checked by test compilation
388 HAVE_SYSTEM=
389 HAVE_FDATE=
390 FC_NAMEMANGLE=
391
392 MODS=
393 TOOLSDIR=
394 SOURCEDIRS=
395 INCLUDEDIRS=
396 STANDARDDIRS=
397
398 PWD=`pwd`
399 MAKE=make
400 AWK=awk
401 THISHOSTNAME=`hostname`
402 THISCWD=`pwd`
403 THISDATE=`date`
404 MACHINE=`uname -a`
405 EXECUTABLE=
406 EXEHOOK=
407 EXEDIR=
408 PACKAGES_CONF=
409 IEEE=
410 if test "x$MITGCM_IEEE" != x ; then
411 IEEE=$MITGCM_IEEE
412 fi
413
414 AUTODIFF_PKG_USED=f
415 AD_OPTFILE=
416 TAF=
417 AD_TAF_FLAGS=
418 FTL_TAF_FLAGS=
419 SVD_TAF_FLAGS=
420 TAF_EXTRA=
421 TAMC=
422 AD_TAMC_FLAGS=
423 FTL_TAF_FLAGS=
424 SVD_TAMC_FLAGS=
425 TAMC_EXTRA=
426
427
428 # The following state can be set directly by command-line switches
429 gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
430 gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
431
432 # The following state is not directly set by command-line switches
433 gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
434 gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
435 gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
436 gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
437 gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
438
439 # The following are all related to adjoint/tangent-linear stuff
440 gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
441 gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
442 gm_s12="TAF_EXTRA TAMC_EXTRA"
443
444 gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
445 gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
446
447
448 echo
449 echo "=== Processing options files and arguments ==="
450 gm_local="genmake_local"
451 for i in . $MODS ; do
452 if test -r $i/$gm_local ; then
453 . $i/$gm_local
454 break
455 fi
456 done
457 echo -n " getting local config information: "
458 if test -e $gm_local ; then
459 echo "using $gm_local"
460 . $gm_local
461 # echo "DISABLE=$DISABLE"
462 # echo "ENABLE=$ENABLE"
463 else
464 echo "none found"
465 fi
466
467 # echo "$0::$1:$2:$3:$4:$5:$6:$7:"
468 #OPTIONS=
469 #n=0
470 #for i ; do
471 # echo "$i $n"
472 # setvar="OPTIONS[$n]='$i'"
473 # # echo " $setvar"
474 # eval "$setvar"
475 # n=$(( $n + 1 ))
476 #done
477 #parse_options
478 ac_prev=
479 for ac_option ; do
480
481 # If the previous option needs an argument, assign it.
482 if test -n "$ac_prev"; then
483 eval "$ac_prev=\$ac_option"
484 ac_prev=
485 continue
486 fi
487
488 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
489
490 case $ac_option in
491
492 -help | --help | -h | --h)
493 usage ;;
494
495 -nooptfile | --nooptfile)
496 OPTFILE="NONE" ;;
497 -optfile | --optfile | -of | --of)
498 ac_prev=OPTFILE ;;
499 -optfile=* | --optfile=* | -of=* | --of=*)
500 OPTFILE=$ac_optarg ;;
501
502 -adoptfile | --adoptfile | -ad | --ad)
503 ac_prev=AD_OPTFILE ;;
504 -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
505 AD_OPTFILE=$ac_optarg ;;
506
507 -pdepend | --pdepend)
508 ac_prev=PDEPEND ;;
509 -pdepend=* | --pdepend=*)
510 PDEPEND=$ac_optarg ;;
511
512 -pdefault | --pdefault)
513 ac_prev=PDEFAULT ;;
514 -pdefault=* | --pdefault=*)
515 PDEFAULT=$ac_optarg ;;
516
517 -make | --make | -m | --m)
518 ac_prev=MAKE ;;
519 -make=* | --make=* | -m=* | --m=*)
520 MAKE=$ac_optarg ;;
521
522 -makefile | --makefile | -ma | --ma)
523 ac_prev=MAKEFILE ;;
524 -makefile=* | --makefile=* | -ma=* | --ma=*)
525 MAKEFILE=$ac_optarg ;;
526
527 -platform | --platform | -pl | --pl)
528 ac_prev=PLATFORM ;;
529 -platform=* | --platform=* | -pl=* | --pl=*)
530 PLATFORM=$ac_optarg ;;
531
532 -rootdir | --rootdir | -rd | --rd)
533 ac_prev=ROOTDIR ;;
534 -rootdir=* | --rootdir=* | -rd=* | --rd=*)
535 ROOTDIR=$ac_optarg ;;
536
537 -mods | --mods | -mo | --mo)
538 ac_prev=MODS ;;
539 -mods=* | --mods=* | -mo=* | --mo=*)
540 MODS=$ac_optarg ;;
541
542 -disable | --disable)
543 ac_prev=DISABLE ;;
544 -disable=* | --disable=*)
545 DISABLE=$ac_optarg ;;
546
547 -enable | --enable)
548 ac_prev=ENABLE ;;
549 -enable=* | --enable=*)
550 ENABLE=$ac_optarg ;;
551
552 -standarddirs | --standarddirs)
553 ac_prev=STANDARDDIRS ;;
554 -standarddirs=* | --standarddirs=*)
555 STANDARDDIRS=$ac_optarg ;;
556
557 -noopt | --noopt)
558 ac_prev=NOOPT ;;
559 -noopt=* | --noopt=*)
560 NOOPT=$ac_optarg ;;
561
562 # -cpp | --cpp)
563 # ac_prev=cpp ;;
564 # -cpp=* | --cpp=*)
565 # CPP=$ac_optarg ;;
566
567 -fortran | --fortran | -fc | --fc)
568 ac_prev=FC ;;
569 -fc=* | --fc=*)
570 FC=$ac_optarg ;;
571
572 -ieee | --ieee)
573 IEEE=true ;;
574 -noieee | --noieee)
575 IEEE= ;;
576
577 -mpi | --mpi)
578 MPI=true ;;
579 -nompi | --nompi)
580 MPI= ;;
581
582 -jam | --jam)
583 JAM=1 ;;
584 -nojam | --nojam)
585 JAM=0 ;;
586
587 -ds | --ds)
588 DUMPSTATE=t ;;
589
590 -taf_extra | --taf_extra)
591 ac_prev=TAF_EXTRA ;;
592 -taf_extra=* | --taf_extra=*)
593 TAF_EXTRA=$ac_optarg ;;
594
595 -tamc_extra | --tamc_extra)
596 ac_prev=TAMC_EXTRA ;;
597 -tamc_extra=* | --tamc_extra=*)
598 TAMC_EXTRA=$ac_optarg ;;
599
600 -*)
601 echo "Error: unrecognized option: "$ac_option
602 usage
603 ;;
604
605 *)
606 echo "Error: unrecognized argument: "$ac_option
607 usage
608 ;;
609
610 esac
611
612 done
613
614 if test -f ./.genmakerc ; then
615 echo
616 echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
617 echo " file. This file format is no longer supported. Please see:"
618 echo
619 echo " http://mitgcm.org/devel_HOWTO/"
620 echo
621 echo " for directions on how to setup and use the new \"genmake2\" input"
622 echo " files and send an email to MITgcm-support@mitgcm.org if you want help."
623 echo
624 fi
625
626 if test "x${ROOTDIR}" = x ; then
627 if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
628 ROOTDIR=".."
629 else
630 for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
631 if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
632 ROOTDIR=$d
633 echo -n "Warning: ROOTDIR was not specified but there appears to be"
634 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
635 break
636 fi
637 done
638 fi
639 fi
640 if test "x${ROOTDIR}" = x ; then
641 echo "Error: Cannot determine ROOTDIR for MITgcm code."
642 echo " Please specify a ROOTDIR using either an options "
643 echo " file or a command-line option."
644 exit 1
645 fi
646 if test ! -d ${ROOTDIR} ; then
647 echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
648 exit 1
649 fi
650
651 echo " getting OPTFILE information: "
652 if test "x${OPTFILE}" = x ; then
653 if test "x$MITGCM_OF" = x ; then
654 echo "Warning: no OPTFILE specified so we'll look for possible settings"
655 printf "\n=== Searching for possible settings for OPTFILE ===\n"
656 find_possible_configs
657 else
658 OPTFILE=$MITGCM_OF
659 fi
660 fi
661 if test "x$OPTFILE" != xNONE ; then
662 if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
663 echo " using OPTFILE=\"$OPTFILE\""
664 . "$OPTFILE"
665 RETVAL=$?
666 if test "x$RETVAL" != x0 ; then
667 echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
668 echo "--please check that variable syntax is bash-compatible"
669 exit 1
670 fi
671 if test "x$DUMPSTATE" != xf ; then
672 cp -f $OPTFILE "genmake_optfile"
673 fi
674 else
675 echo "Error: can't read OPTFILE=\"$OPTFILE\""
676 exit 1
677 fi
678 fi
679
680 echo " getting AD_OPTFILE information: "
681 if test "x${AD_OPTFILE}" = x ; then
682 if test "x$MITGCM_AD_OF" = x ; then
683 AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
684 else
685 AD_OPTFILE=$MITGCM_AD_OF
686 fi
687 fi
688 if test "x${AD_OPTFILE}" != xNONE ; then
689 if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
690 echo " using AD_OPTFILE=\"$AD_OPTFILE\""
691 . "$AD_OPTFILE"
692 RETVAL=$?
693 if test "x$RETVAL" != x0 ; then
694 echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
695 echo "--please check that variable syntax is bash-compatible"
696 exit 1
697 fi
698 if test "x$DUMPSTATE" != xf ; then
699 cp -f $AD_OPTFILE "genmake_ad_optfile"
700 fi
701 else
702 echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
703 exit 1
704 fi
705 fi
706
707 # Check that FC, LINK, CPP, S64, and LN are defined. If not,
708 # complain and abort!
709 if test "x$FC" = x ; then
710 cat <<EOF 1>&2
711
712 Error: no Fortran compiler: please specify using one of the following:
713 1) within the options file ("FC=...") as specified by "-of=OPTFILE"
714 2) the "-fc=XXX" command-line option
715 3) the "./genmake_local" file
716 EOF
717 exit 1
718 fi
719 if test "x$LINK" = x ; then
720 LINK=$FC
721 fi
722 if test "x$CPP" = x ; then
723 CPP="cpp"
724 fi
725 echo "#define A a" | $CPP > test_cpp 2>&1
726 RETVAL=$?
727 if test "x$RETVAL" != x0 ; then
728 cat <<EOF 1>&2
729
730 Error: C pre-processor "$CPP" failed the test case: please specify using:
731
732 1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
733 2) the "./genmake_local" file
734 3) with the CPP environment variable
735
736 EOF
737 exit 1
738 else
739 rm -f test_cpp
740 fi
741 if test "x$MAKEDEPEND" = x ; then
742 MAKEDEPEND=makedepend
743 fi
744 if test "x$LN" = x ; then
745 LN="ln -s"
746 fi
747 echo "test" > genmake_test_ln
748 $LN genmake_test_ln genmake_tlink
749 RETVAL=$?
750 if test "x$RETVAL" != x0 ; then
751 cat <<EOF 1>&2
752
753 Error: The command "ln -s" failed -- please specify a working soft-link
754 command in the optfile.
755
756 EOF
757 exit 1
758 fi
759 rm -f genmake_test_ln genmake_tlink
760
761 printf "\n=== Checking system libraries ===\n"
762 echo -n " Do we have the system() command using $FC... "
763 cat > genmake_tcomp.f <<EOF
764 program hello
765 call system('echo hi')
766 end
767 EOF
768 $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
769 RETVAL=$?
770 if test "x$RETVAL" = x0 ; then
771 HAVE_SYSTEM=t
772 DEFINES="$DEFINES -DHAVE_SYSTEM"
773 echo "yes"
774 else
775 HAVE_SYSTEM=
776 echo "no"
777 fi
778 rm -f genmake_tcomp*
779
780 echo -n " Do we have the fdate() command using $FC... "
781 cat > genmake_tcomp.f <<EOF
782 program hello
783 CHARACTER(128) string
784 string = ' '
785 call fdate( string )
786 print *, string
787 end
788 EOF
789 $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
790 RETVAL=$?
791 if test "x$RETVAL" = x0 ; then
792 HAVE_FDATE=t
793 DEFINES="$DEFINES -DHAVE_FDATE"
794 echo "yes"
795 else
796 HAVE_FDATE=
797 echo "no"
798 fi
799 rm -f genmake_tcomp*
800
801 echo " The name mangling convention for $FC is... "
802 #FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"
803 if test "x$FC_NAMEMANGLE" = x ; then
804 get_fortran_c_namemangling
805 fi
806 echo " '$FC_NAMEMANGLE'"
807 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template
808 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1
809 RETVAL=$?
810 if test "x$RETVAL" != x0 ; then
811 mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h
812 fi
813
814
815 printf "\n=== Setting defaults ===\n"
816 echo -n " Adding MODS directories: "
817 for d in $MODS ; do
818 if test ! -d $d ; then
819 echo
820 echo "Error: MODS directory \"$d\" not found!"
821 exit 1
822 else
823 echo -n " $d"
824 SOURCEDIRS="$SOURCEDIRS $d"
825 INCLUDEDIRS="$INCLUDEDIRS $d"
826 fi
827 done
828 echo
829
830 if test "x$MAKEFILE" = x ; then
831 MAKEFILE="Makefile"
832 fi
833 if test "x${PLATFORM}" = x ; then
834 PLATFORM=$p_PLATFORM
835 fi
836
837 if test "x${EXEDIR}" = x ; then
838 if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then
839 EXEDIR=../exe
840 else
841 EXEDIR=.
842 fi
843 fi
844 if test ! -d ${EXEDIR} ; then
845 echo "Error: the specified EXEDIR (\"$EXEDIR\") does not exist!"
846 exit 1
847 fi
848
849 if test "x${TOOLSDIR}" = x ; then
850 TOOLSDIR="$ROOTDIR/tools"
851 fi
852 if test ! -d ${TOOLSDIR} ; then
853 echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"
854 exit 1
855 fi
856 if test "x$S64" = x ; then
857 S64='$(TOOLSDIR)/set64bitConst.sh'
858 fi
859
860 EXECUTABLE=${EXECUTABLE:-mitgcmuv}
861
862 # We have a special set of source files in eesupp/src which are
863 # generated from some template source files. We'll make them first so
864 # they appear as regular source code
865 if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
866 echo " Making source files in eesupp from templates"
867 ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
868 RETVAL=$?
869 if test "x${RETVAL}" = x0 ; then
870 rm -f make_eesupp.errors
871 else
872 echo "Error: problem encountered while building source files in eesupp:"
873 cat make_eesupp.errors
874 exit 1
875 fi
876 fi
877
878 printf "\n=== Determining package settings ===\n"
879 if test "x${PDEPEND}" = x ; then
880 tmp=$ROOTDIR"/pkg/pkg_depend"
881 if test -r $tmp ; then
882 PDEPEND=$tmp
883 else
884 echo "Warning: No package dependency information was specified."
885 echo " Please check that ROOTDIR/pkg/pkg_depend exists."
886 fi
887 else
888 if test ! -r ${PDEPEND} ; then
889 echo "Error: can't read package dependency info from PDEPEND=\"$PDEPEND\""
890 exit 1
891 fi
892 fi
893 echo " getting package dependency info from $PDEPEND"
894 # Strip the comments and then convert the dependency file into
895 # two arrays: PNAME, DNAME
896 cat $PDEPEND | sed -e 's/#.*$//g' \
897 | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
898 > ./.pd_tmp
899 RETVAL=$?
900 if test ! "x${RETVAL}" = x0 ; then
901 echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
902 exit 1
903 fi
904 . ./.pd_tmp
905 rm -f ./.pd_tmp
906
907 # Search for default packages. Note that a "$ROOTDIR/pkg/pkg_groups"
908 # file should eventually be added so that, for convenience, one can
909 # specify groups of packages using names like "ocean" and "atmosphere".
910 echo -n " checking default package list: "
911 if test "x${PDEFAULT}" = x ; then
912 for i in "." $MODS ; do
913 if test -r $i"/packages.conf" ; then
914 PDEFAULT=$i"/packages.conf"
915 break
916 fi
917 done
918 fi
919 if test "x${PDEFAULT}" = x ; then
920 PDEFAULT="$ROOTDIR/pkg/pkg_default"
921 fi
922 if test "x${PDEFAULT}" = xNONE ; then
923 echo "default packages file disabled"
924 else
925 if test ! -r $PDEFAULT ; then
926 echo ""
927 echo "Warning: can't read default packages from PDEFAULT=\"$PDEFAULT\""
928 else
929 echo " using PDEFAULT=\"$PDEFAULT\""
930 # Strip the comments and add all the names
931 def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
932 RETVAL=$?
933 if test "x${RETVAL}" != x0 ; then
934 echo -n "Error: can't parse default package list "
935 echo "-- please check PDEFAULT=\"$PDEFAULT\""
936 exit 1
937 fi
938 for i in $def ; do
939 PACKAGES="$PACKAGES $i"
940 done
941 echo " before group expansion packages are: $PACKAGES"
942 expand_pkg_groups
943 echo " after group expansion packages are: $PACKAGES"
944 fi
945 fi
946
947 echo " applying DISABLE settings"
948 pack=
949 for p in $PACKAGES ; do
950 addit="t"
951 for d in $DISABLE ; do
952 if test "x$p" = "x$d" ; then
953 addit="f"
954 fi
955 done
956 if test "x$addit" = xt ; then
957 pack="$pack $p"
958 fi
959 done
960 PACKAGES="$pack"
961 echo " applying ENABLE settings"
962 echo "" > ./.tmp_pack
963 PACKAGES="$PACKAGES $ENABLE"
964 for i in $PACKAGES ; do
965 if test ! -d "$ROOTDIR/pkg/$i" ; then
966 echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
967 exit 1
968 fi
969 echo $i >> ./.tmp_pack
970 done
971 pack=`cat ./.tmp_pack | sort | uniq`
972 rm -f ./.tmp_pack
973 PACKAGES=
974 for i in $pack ; do
975 PACKAGES="$PACKAGES $i"
976 done
977 echo " packages are: $PACKAGES"
978
979 echo " applying package dependency rules"
980 ck=
981 while test "x$ck" != xtt ; do
982 i=0
983 # rtot=${#PNAME[@]}
984 rtot=$nname
985 while test $i -lt $rtot ; do
986
987 # Is $pname in the current $PACKAGES list?
988 # pname=${PNAME[$i]}
989 tmp="pname=\"\$PNAME_$i\""
990 eval $tmp
991 pin="f"
992 for p in $PACKAGES ; do
993 if test "x$p" = "x$pname" ; then
994 pin="t"
995 fi
996 done
997
998 # Is the DNAME entry a (+) or (-) rule ?
999 tmp="dname=\"\$DNAME_$i\""
1000 eval $tmp
1001 plus="-"
1002 echo $dname | grep '^+' > /dev/null 2>&1
1003 RETVAL=$?
1004 if test "x$RETVAL" = x0 ; then
1005 plus="+"
1006 fi
1007
1008 # Is $dname in the current $PACKAGES list?
1009 dname=`echo $dname | sed -e 's/^[+-]//'`
1010 din="f"
1011 for p in $PACKAGES ; do
1012 if test "x$p" = "x$dname" ; then
1013 din="t"
1014 fi
1015 done
1016
1017 # Do we need to add $dname according to the dependency rules?
1018 if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
1019 in_dis="f"
1020 for dis in $DISABLE ; do
1021 if test "x$dis" = "x$dname" ; then
1022 in_dis="t"
1023 fi
1024 done
1025 if test "x$in_dis" = xt ; then
1026 echo "Error: can't satisfy package dependencies:"
1027 echo " \"$dname\" is required by the dependency rules"
1028 echo " but is disallowed by the DISABLE settings"
1029 exit 1
1030 else
1031 PACKAGES="$PACKAGES $dname"
1032 ck=
1033 fi
1034 fi
1035
1036 # Do we need to get rid of $dname according to the dependency rules?
1037 if test "x$pin" = xt -a "x$plus" = "x-" -a "x$din" = xt; then
1038 echo "Error: can't satisfy package dependencies:"
1039 echo " \"$pname\" was requested but is disallowed by"
1040 echo " the dependency rules for \"$dname\""
1041 exit 1
1042 fi
1043 i=$(( $i + 1 ))
1044 done
1045 ck=$ck"t"
1046 done
1047 echo " packages are: $PACKAGES"
1048 for i in $PACKAGES ; do
1049 adr="$ROOTDIR/pkg/$i"
1050 if test -d $adr ; then
1051 SOURCEDIRS="$SOURCEDIRS $adr"
1052 INCLUDEDIRS="$INCLUDEDIRS $adr"
1053 if test "x$i" = xautodiff ; then
1054 AUTODIFF_PKG_USED=t
1055 fi
1056 else
1057 echo "Error: the directory \"$adr\" for package $i doesn't exist"
1058 exit 1
1059 fi
1060 done
1061
1062
1063 # Create a list of #define and #undef to enable/disable packages
1064 PACKAGES_DOT_H=PACKAGES_CONFIG.h
1065 cat <<EOF >$PACKAGES_DOT_H".tmp"
1066 C=== GENMAKE v2 ===
1067 C The following defines have been set by GENMAKE, so please do not
1068 C edit anything below these comments. In general, you should
1069 C add or remove packages by re-running genmake with different
1070 C "-enable" and/or "-disable" options.
1071
1072 #ifndef PACKAGES_H
1073 #define PACKAGES_H
1074
1075 C Packages disabled by genmake:
1076 EOF
1077 # The following UGLY HACK sets multiple "#undef"s and it needs to go
1078 # away. On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1079 # file would eventually be split up so that all package-related #define
1080 # statements could be separated and handled only by genmake.
1081 names=`ls -1 "$ROOTDIR/pkg"`
1082 all_pack=
1083 for n in $names ; do
1084 if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1085 has_pack="f"
1086 for pack in $PACKAGES ; do
1087 if test "x$pack" = "x$n" ; then
1088 has_pack="t"
1089 break
1090 fi
1091 done
1092 if test "x$has_pack" = xf ; then
1093 undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1094 echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
1095 fi
1096 fi
1097 done
1098 cat <<EOF >>$PACKAGES_DOT_H".tmp"
1099
1100 C Packages enabled by genmake:
1101 EOF
1102 for i in $PACKAGES ; do
1103 def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1104 echo "#define $def" >> $PACKAGES_DOT_H".tmp"
1105 #eh3 DEFINES="$DEFINES -D$def"
1106
1107 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
1108 case $i in
1109 aim_v23)
1110 echo "#define ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"
1111 DEFINES="$DEFINES -DALLOW_AIM"
1112 echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
1113 ;;
1114 esac
1115 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
1116
1117 done
1118 cat <<EOF >>$PACKAGES_DOT_H".tmp"
1119
1120 #endif /* PACKAGES_H */
1121 EOF
1122
1123 if test ! -f $PACKAGES_DOT_H ; then
1124 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1125 else
1126 cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1127 RETVAL=$?
1128 if test "x$RETVAL" = x0 ; then
1129 rm -f $PACKAGES_DOT_H".tmp"
1130 else
1131 mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1132 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1133 fi
1134 fi
1135
1136 echo " Adding STANDARDDIRS"
1137 BUILDDIR=${BUILDDIR:-.}
1138 if test "x$STANDARDDIRS" = x ; then
1139 STANDARDDIRS="eesupp model"
1140 fi
1141 for d in $STANDARDDIRS ; do
1142 adr="$ROOTDIR/$d/src"
1143 if test ! -d $adr ; then
1144 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1145 echo " is correct and that you correctly specified the STANDARDDIRS option"
1146 exit 1
1147 else
1148 SOURCEDIRS="$SOURCEDIRS $adr"
1149 fi
1150 adr="$ROOTDIR/$d/inc"
1151 if test ! -d $adr ; then
1152 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1153 echo " is correct and that you correctly specified the STANDARDDIRS option"
1154 exit 1
1155 else
1156 INCLUDEDIRS="$INCLUDEDIRS $adr"
1157 fi
1158 done
1159
1160 echo " Searching for CPP_OPTIONS.h in order to warn about the presence"
1161 echo " of \"#define ALLOW_PKGNAME\"-type statements:"
1162 CPP_OPTIONS=
1163 spaths=". $INCLUDEDIRS"
1164 for i in $spaths ; do
1165 try="$i/CPP_OPTIONS.h"
1166 # echo -n " trying $try : "
1167 if test -f $try -a -r $try ; then
1168 echo " found CPP_OPTIONS=\"$try\""
1169 CPP_OPTIONS="$try"
1170 break
1171 fi
1172 done
1173 if test "x$CPP_OPTIONS" = x ; then
1174 echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1175 exit 1
1176 fi
1177 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1178 names=`ls -1 "$ROOTDIR/pkg"`
1179 for n in $names ; do
1180 test_for_package_in_cpp_options $CPP_OPTIONS $n
1181 done
1182
1183
1184 # Here, we build the list of files to be "run through" the adjoint
1185 # compiler.
1186 if test -f ./ad_files ; then
1187 rm -f ./ad_files
1188 fi
1189 echo " Creating the list of files for the adjoint compiler."
1190 for i in $SOURCEDIRS ; do
1191 list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1192 for j in $list_files ; do
1193 cat $i/$j >> ad_files
1194 done
1195 done
1196
1197 cat <<EOF > adjoint_sed
1198 s/call adopen(/call adopen ( mythid,\\
1199 \& /g
1200 s/call adclose(/call adclose( mythid,\\
1201 \& /g
1202 s/call adread(/call adread ( mythid,\\
1203 \& /g
1204 s/call adwrite(/call adwrite( mythid,\\
1205 \& /g
1206
1207 EOF
1208
1209 echo
1210 echo "=== Creating the Makefile ==="
1211 echo " setting INCLUDES"
1212 for i in $INCLUDEDIRS ; do
1213 if ! test -d $i ; then
1214 # INCLUDES="$INCLUDES -I$i"
1215 # else
1216 echo "Warning: can't find INCLUDEDIRS=\"$i\""
1217 fi
1218 done
1219
1220 echo " Determining the list of source and include files"
1221 rm -rf .links.tmp
1222 mkdir .links.tmp
1223 echo "# This section creates symbolic links" > srclinks.tmp
1224 echo "" >> srclinks.tmp
1225 echo -n 'SRCFILES = ' > srclist.inc
1226 echo -n 'CSRCFILES = ' > csrclist.inc
1227 echo -n 'F90SRCFILES = ' > f90srclist.inc
1228 echo -n 'HEADERFILES = ' > hlist.inc
1229 echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1230 alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1231 for d in $alldirs ; do
1232 deplist=
1233 sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1234 sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1235 for sf in $sfiles ; do
1236 if test ! -r ".links.tmp/$sf" ; then
1237 if test -f "$d/$sf" ; then
1238 extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1239 touch .links.tmp/$sf
1240 deplist="$deplist $sf"
1241 case $extn in
1242 F)
1243 echo " \\" >> srclist.inc
1244 echo -n " $sf" >> srclist.inc
1245 ;;
1246 F90)
1247 echo " \\" >> f90srclist.inc
1248 echo -n " $sf" >> f90srclist.inc
1249 ;;
1250 c)
1251 echo " \\" >> csrclist.inc
1252 echo -n " $sf" >> csrclist.inc
1253 ;;
1254 h)
1255 echo " \\" >> hlist.inc
1256 echo -n " $sf" >> hlist.inc
1257 ;;
1258 flow)
1259 echo " \\" >> ad_flow_files.inc
1260 echo -n " $sf" >> ad_flow_files.inc
1261 ;;
1262 esac
1263 fi
1264 fi
1265 done
1266 if test "x$deplist" != x ; then
1267 echo "" >> srclinks.tmp
1268 echo "# These files are linked from $d" >> srclinks.tmp
1269 echo "$deplist :" >> srclinks.tmp
1270 printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp
1271 fi
1272 done
1273 rm -rf .links.tmp
1274 echo "" >> srclist.inc
1275 echo "" >> csrclist.inc
1276 echo "" >> f90srclist.inc
1277 echo "" >> hlist.inc
1278 echo "" >> ad_flow_files.inc
1279
1280 if test -e $MAKEFILE ; then
1281 mv -f $MAKEFILE "$MAKEFILE.bak"
1282 fi
1283 echo " Writing makefile: $MAKEFILE"
1284 echo "# Multithreaded + multi-processing makefile for:" > $MAKEFILE
1285 echo "# $MACHINE" >> $MAKEFILE
1286 echo "# This makefile was generated automatically on" >> $MAKEFILE
1287 echo "# $THISDATE" >> $MAKEFILE
1288 echo "# by the command:" >> $MAKEFILE
1289 echo "# $0 $@" >> $MAKEFILE
1290 echo "# executed by:" >> $MAKEFILE
1291 echo "# $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1292
1293 EXE_AD=$EXECUTABLE"_ad"
1294 EXE_FTL=$EXECUTABLE"_ftl"
1295 EXE_SVD=$EXECUTABLE"_svd"
1296
1297 cat >>$MAKEFILE <<EOF
1298 #
1299 # BUILDDIR : Directory where object files are written
1300 # SOURCEDIRS : Directories containing the source (.F) files
1301 # INCLUDEDIRS : Directories containing the header-source (.h) files
1302 # EXEDIR : Directory where executable that is generated is written
1303 # EXECUTABLE : Full path of executable binary
1304 #
1305 # CPP : C-preprocessor command
1306 # INCLUDES : Directories searched for header files
1307 # DEFINES : Macro definitions for CPP
1308 # MAKEDEPEND : Dependency generator
1309 # KPP : Special preprocessor command (specific to platform)
1310 # KFLAGS : Flags for KPP
1311 # FC : Fortran compiler command
1312 # FFLAGS : Configuration/debugging options for FC
1313 # FOPTIM : Optimization options for FC
1314 # LINK : Command for link editor program
1315 # LIBS : Library flags /or/ additional optimization/debugging flags
1316
1317 ROOTDIR = ${ROOTDIR}
1318 BUILDDIR = ${BUILDDIR}
1319 SOURCEDIRS = ${SOURCEDIRS}
1320 INCLUDEDIRS = ${INCLUDEDIRS}
1321 EXEDIR = ${EXEDIR}
1322 EXECUTABLE = \$(EXEDIR)/${EXECUTABLE}
1323 TOOLSDIR = ${TOOLSDIR}
1324
1325 #eh3 new defines for the adjoint work
1326 AUTODIFF = ${ROOTDIR}/pkg/autodiff
1327 EXE_AD = ${EXE_AD}
1328 EXE_FTL = ${EXE_FTL}
1329 EXE_SVD = ${EXE_SVD}
1330
1331 EOF
1332
1333 # Note: figure out some way to add Hyades JAM libraries here
1334
1335 cat >>$MAKEFILE <<EOF
1336 # Unix ln (link)
1337 LN = ${LN}
1338 # C preprocessor
1339 CPP = cat \$< | ${S64} | ${CPP}
1340 # Dependency generator
1341 MAKEDEPEND = ${MAKEDEPEND}
1342 # Special preprocessor (KAP on DECs, FPP on Crays)
1343 KPP = ${KPP}
1344 # Fortran compiler
1345 FC = ${FC}
1346 # Fortran compiler
1347 F90C = ${F90C}
1348 # Link editor
1349 LINK = ${LINK}
1350
1351 # Defines for CPP
1352 DEFINES = ${DEFINES}
1353 # Includes for CPP
1354 INCLUDES = ${INCLUDES}
1355 # Flags for KPP
1356 KFLAGS1 = ${KFLAGS1}
1357 KFLAGS2 = ${KFLAGS2}
1358 # Optim./debug for FC
1359 FFLAGS = ${FFLAGS}
1360 FOPTIM = ${FOPTIM}
1361 # Optim./debug for FC
1362 F90FLAGS = ${F90FLAGS}
1363 F90OPTIM = ${F90OPTIM}
1364 # Flags for CC
1365 CFLAGS = ${CFLAGS}
1366 # Files that should not be optimized
1367 NOOPTFILES = ${NOOPTFILES}
1368 NOOPTFLAGS = ${NOOPTFLAGS}
1369 # Flags and libraries needed for linking
1370 LIBS = ${LIBS} \$(XLIBS)
1371 # Name of the Mekfile
1372 MAKEFILE=${MAKEFILE}
1373
1374 EOF
1375
1376 cat srclist.inc >> $MAKEFILE
1377 cat csrclist.inc >> $MAKEFILE
1378 cat f90srclist.inc >> $MAKEFILE
1379 cat hlist.inc >> $MAKEFILE
1380 cat ad_flow_files.inc >> $MAKEFILE
1381 echo >> $MAKEFILE
1382 echo 'F77FILES = $(SRCFILES:.F=.f)' >> $MAKEFILE
1383 echo 'F90FILES = $(F90SRCFILES:.F90=.f90)' >> $MAKEFILE
1384 echo 'OBJFILES = $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1385
1386 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1387 rm -f ad_flow_files.inc
1388
1389 cat >>$MAKEFILE <<EOF
1390
1391 .SUFFIXES:
1392 .SUFFIXES: .o .f .p .F .c .F90 .f90
1393
1394 all: \$(EXECUTABLE)
1395 \$(EXECUTABLE): \$(OBJFILES)
1396 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1397 depend:
1398 @make links
1399 \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1400 ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)
1401
1402 links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)
1403
1404 small_f: \$(F77FILES) \$(F90FILES)
1405
1406 output.txt: \$(EXECUTABLE)
1407 @printf 'running ... '
1408 @\$(EXECUTABLE) > \$@
1409
1410 clean:
1411 -cat AD_CONFIG.template > AD_CONFIG.h
1412 -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}
1413 Clean:
1414 @make clean
1415 @make cleanlinks
1416 -rm -f Makefile.bak genmake_state genmake_*optfile make.log
1417 CLEAN:
1418 @make Clean
1419 -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1420 -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1421 -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1422 -rm -f \$(EXECUTABLE) output.txt
1423
1424 #eh3 Makefile: makefile
1425 makefile:
1426 ${0} $@
1427 cleanlinks:
1428 -find . -type l -exec rm {} \;
1429
1430 # The normal chain of rules is ( .F - .f - .o )
1431 .F.f:
1432 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1433 .f.o:
1434 \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1435 .F90.f90:
1436 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1437 .f90.o:
1438 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1439 .c.o:
1440 \$(CC) \$(CFLAGS) -c \$<
1441
1442 # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain
1443 .F.p:
1444 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1445 .p.f:
1446 \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1447
1448 #=========================================
1449 #=== Automatic Differentiation Rules ===
1450
1451 TAMC = ${TAMC}
1452 TAF = ${TAF}
1453
1454 TAF_EXTRA = ${TAF_EXTRA}
1455 TAMC_EXTRA = ${TAMC_EXTRA}
1456
1457 EOF
1458
1459 ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1460 ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1461 ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1462 for i in $ad_vars ; do
1463 name=$i
1464 t1="t2=\$"`echo $i`
1465 eval $t1
1466 printf "%-20s = " $name >> $MAKEFILE
1467 echo $t2 >> $MAKEFILE
1468 done
1469
1470 echo " Add the source list for AD code generation"
1471 echo >> $MAKEFILE
1472 echo -n "AD_FILES = " >> $MAKEFILE
1473 AD_FILES=`cat ad_files`
1474 for i in $AD_FILES ; do
1475 echo " \\" >> $MAKEFILE
1476 echo -n " $i" >> $MAKEFILE
1477 done
1478 echo >> $MAKEFILE
1479 rm -f ad_files
1480
1481 cat >>$MAKEFILE <<EOF
1482
1483 # ... AD ...
1484 adall: ad_taf
1485 adtaf: ad_taf_output.f
1486 adtamc: ad_tamc_output.f
1487
1488 ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1489 cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1490 @make \$(F77FILES)
1491 @make \$(AD_FLOW_FILES)
1492 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1493
1494 ad_taf_output.f: ad_input_code.f
1495 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1496 cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1497
1498 adtafonly:
1499 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1500 cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1501
1502 ad_taf: ad_taf_output.o \$(OBJFILES)
1503 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1504
1505 ad_tamc_output.f: ad_input_code.f
1506 \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1507 cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f
1508
1509 ad_tamc: ad_tamc_output.o \$(OBJFILES)
1510 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1511
1512
1513 # ... FTL ...
1514 ftlall: ftl_taf
1515 ftltaf: ftl_taf_output.f
1516 ftltamc: ftl_tamc_output.f
1517
1518 ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1519 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1520 @make \$(F77FILES)
1521 @make \$(AD_FLOW_FILES)
1522 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1523
1524 ftl_taf_output.f: ftl_input_code.f
1525 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1526 cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f
1527
1528 ftl_taf: ftl_taf_output.o \$(OBJFILES)
1529 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1530
1531 ftl_tamc_output.f: ftl_input_code.f
1532 \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1533 cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f
1534
1535 ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1536 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1537
1538
1539 # ... SVD ...
1540 svd: svd_taf
1541 svd_taf_f: svd_taf_output.f
1542
1543 svd_input_code.f: \$(SRCFILES)
1544 cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h
1545 @make \$(F77FILES)
1546 @make \$(AD_FLOW_FILES)
1547 cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f
1548
1549 svd_taf_output.f: svd_input_code.f
1550 \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f
1551 cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f
1552
1553 svd_taf: svd_taf_output.o \$(OBJFILES)
1554 \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)
1555
1556
1557 #=========================================
1558
1559 EOF
1560
1561 if test "x$EXEHOOK" != x ; then
1562 printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
1563 fi
1564
1565 echo " Making list of \"exceptions\" that need \".p\" files"
1566 for i in $KPPFILES ; do
1567 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
1568 RETVAL=$?
1569 if test "x$RETVAL" != x0 ; then
1570 echo "Error: unable to add file \"$i\" to the exceptions list"
1571 fi
1572 echo "$base.f: $base.p" >> $MAKEFILE
1573 done
1574
1575 echo " Making list of NOOPTFILES"
1576 for i in $NOOPTFILES ; do
1577 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
1578 RETVAL=$?
1579 if test "x$RETVAL" != x0 ; then
1580 echo "Error: unable to add file \"$i\" to the exceptions list"
1581 fi
1582 echo "$base.o: $base.f" >> $MAKEFILE
1583 printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
1584 done
1585
1586 echo " Add rules for links"
1587 cat srclinks.tmp >> $MAKEFILE
1588 rm -f srclinks.tmp
1589
1590 echo " Adding makedepend marker"
1591 printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
1592
1593 printf "\n=== Done ===\n"
1594
1595 # Write the "template" files for the adjoint builds
1596 cat >AD_CONFIG.template <<EOF
1597 C WARNING: This file is automatically generated by genmake2 and
1598 C used by the Makefile rules. Please DO NOT EDIT this file
1599 C unless you are CERTAIN that you know what you are doing.
1600
1601 #undef ALLOW_ADJOINT_RUN
1602 #undef ALLOW_TANGENTLINEAR_RUN
1603 #undef ALLOW_ECCO_OPTIMIZATION
1604 EOF
1605 cat >ad_config.template <<EOF
1606 C WARNING: This file is automatically generated by genmake2 and
1607 C used by the Makefile rules. Please DO NOT EDIT this file
1608 C unless you are CERTAIN that you know what you are doing.
1609
1610 #define ALLOW_ADJOINT_RUN
1611 #undef ALLOW_TANGENTLINEAR_RUN
1612 #undef ALLOW_ECCO_OPTIMIZATION
1613 EOF
1614 cat >ftl_config.template <<EOF
1615 C WARNING: This file is automatically generated by genmake2 and
1616 C used by the Makefile rules. Please DO NOT EDIT this file
1617 C unless you are CERTAIN that you know what you are doing.
1618
1619 #undef ALLOW_ADJOINT_RUN
1620 #define ALLOW_TANGENTLINEAR_RUN
1621 #undef ALLOW_ECCO_OPTIMIZATION
1622 EOF
1623 cat >svd_config.template <<EOF
1624 C WARNING: This file is automatically generated by genmake2 and
1625 C used by the Makefile rules. Please DO NOT EDIT this file
1626 C unless you are CERTAIN that you know what you are doing.
1627
1628 #undef ALLOW_ADJOINT_RUN
1629 #undef ALLOW_TANGENTLINEAR_RUN
1630 #undef ALLOW_ECCO_OPTIMIZATION
1631 EOF
1632 cp AD_CONFIG.template AD_CONFIG.h
1633
1634
1635 # Write the "state" for future records
1636 if test "x$DUMPSTATE" != xf ; then
1637 echo -n "" > genmake_state
1638 for i in $gm_state ; do
1639 t1="t2=\$$i"
1640 eval $t1
1641 echo "$i='$t2'" >> genmake_state
1642 done
1643 fi

  ViewVC Help
Powered by ViewVC 1.1.22